local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	login_callback = nil,
	force_logout = false,
	is_login_verify_ing = false,
	login_verify_url = "cls.cp01.youyannet.com/b04/login_verify.php",
	uid = "",
}

function PlatformAdapter:OpenExitDialog()

	agent_helper:Exit(function(result) 
		if "true" == result then
			AdapterToLua:endGame()
		end
	end)

end

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end

	local cache_data = Split((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), "_")
	if cache_data ~= nil then
		GLOBAL_CONFIG.package_info.config.agent_id = cache_data[1] or "b04"
		self.uid = cache_data[2] or ""
	end

	print("===========", self.uid)
	self:SetChanneId(self.uid)

	self.is_init = true
	AgentMs:InitLocalPush()

	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

--平台ID
function AgentAdapter:GetSpid()
	return GLOBAL_CONFIG.package_info.config.agent_id
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

function AgentAdapter:GetChannelId()
	return "b04"
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid() .. "_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[116] 
end

--获得logo资源名
function AgentAdapter:GetLogoResName()

	local logo_tf = PlatformBinder:JsonCall("call_agent_logo")

	if logo_tf == "true" then
		return "big_logo_dxsw_hk7"
	elseif logo_tf == "false" then
		return "empty_logo"--无
	end

end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_login_bg_xmzz_b05"
end

function AgentAdapter:LoginCallback(result)
	local json_obj = cjson.decode(result)
	self.uid = json_obj.uid

	local verify_callback = function(url, arg, data, size)
		self.is_login_verify_ing = false
		if size <= 0 then
			Log("verify_callback, fail:size<=0")
			return
		end
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			Log("verify_callback, fail")
			return
		end
		self.uid = ret_t.user.uid
		self:SetChanneId(self.uid)
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())
	end

	self.is_login_verify_ing = true
	local real_url = string.format("%s?spid=%s&uid=%s&userName=%s&token=%s", self.login_verify_url, self:GetSpid(), json_obj.uid, json_obj.userName, json_obj.token)
	Log("start verify login: url=" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)
end

function AgentAdapter:Login(callback)
	self.login_callback = callback
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end


function AgentAdapter:LogoutCallback(result)
		self.uid = ""
		--if not LoginController.Instance:AgentLoginViewIsOpen() then
			ReStart()
	    --end
	return true
end

function AgentAdapter:Logout()
	self:LogoutCallback("true")
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)

	local info = {}
	info.orderId = server_id .. "_" .. self:GetPlatName() .. "_" .. os.time()
	info.goods = "元宝"	
	info.money = amount * 100
	info.ext = ""

	agent_helper:Pay(cjson.encode(info), callback)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	local info = {}
	info.roleId = tostring(role_id)
	info.zoneId = zone_id
	info.roleName = role_name
	info.roleLevel = tostring(role_level)
	info.zoneName = zone_name
	agent_helper:SubmitExtendData(cjson.encode(info))
end


-- 是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

channelIds = {}

channelIds["2081603487"] = "y73"		--仙魔之战-应用宝    
channelIds["1370308097"] = "y74"		--仙魔之战-小米	     
channelIds["1876218605"] = "y75"		--仙魔之战-UC

function AgentAdapter:SetChanneId(channeld)
	if "" ~= self.uid then
		local split_data = Split(self.uid, "-")
		if nil ~= split_data then
			channeld = split_data[1] or ""
			print("channeld====", channeld)
			GLOBAL_CONFIG.package_info.config.agent_id = channelIds[channeld] or "b04"
			print("channeld==", GLOBAL_CONFIG.package_info.config.agent_id)
		end
	end
end