local agent_helper = {
	LOGLEVEL_ERROR = 0,	--错误信息级别，记录错误日志
	LOGLEVEL_WARN = 1,	--警告信息级别，记录错误和警告日志
	LOGLEVEL_DEBUG = 2,	--调试信息级别，记录错误、警告和调试信息，为最详尽的日志级别

	cp_id = 28559,
	game_id = 1001397,
}

--void (*UCCallback)(int code, const char *pszmsg);

-- static void initSDK(bool debugMode, int logLevel, int cpId, int gameId,
-- 	int serverId, const char *pszServerName, bool enablePayHistory,
-- 	bool enableLogout, UCCallback initResultCallback)

function agent_helper:Init(callback)
	local param = cjson.encode(
	{
		logLevel = agent_helper.LOGLEVEL_DEBUG,
		debugMode = false,
		cpId = self.cp_id,
		gameId = self.game_id,
		enablePayHistory = true,
		enableLogout = true,
	} )
	PlatformBinder:JsonCall("call_agent_init", param, "", callback)
end

function agent_helper:Login(callback)--（call）调用java端，调出登录界面，并且绑定回调函数
	PlatformBinder:JsonCall("call_agent_login", "", "", callback)
end

function agent_helper:GetSessionId()
	return PlatformBinder:JsonCall("call_agent_get_sid")
end

function agent_helper:Logout()
	PlatformBinder:JsonCall("call_agent_logout")
end

function agent_helper:Exit(callback)
	PlatformBinder:JsonCall("call_agent_exit", "", "", callback)
end

--浮标的切换账号，用这个方法来返回到登陆界面
function agent_helper:LogoutFloat(callback)
	PlatformBinder:JsonCall("call_agent_logout_float", "", "", callback)
end

function agent_helper:ShowFloatButton()
	PlatformBinder:JsonCall("call_agent_show_float_button");
end

function agent_helper:Pay(param)--购买
	PlatformBinder:JsonCall("call_agent_pay", param)
end

function agent_helper:SubmitExtendData(param)
	PlatformBinder:JsonCall("send_user_info", param)
end

function agent_helper:EnterUserCenter(callback)
	PlatformBinder:JsonCall("call_agent_enter_user_center", param, "", callback)
end

return agent_helper 
