AgentAdapter = {
	is_init = false,
	login_flag = false,
	user_id = "",
	session_id = "",

	pay_callback_url="http://cls.cp01.youyannet.com/qbd/pay.php";
}

--按返回键的时候调用这个方法
function PlatformAdapter:OpenExitDialog()

	PlatformBinder:JsonCall("call_agent_exit", "", "", function(result) 

		if "true" == result then
			AdapterToLua:endGame()
		end

	end)
	
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "qbd"
end



-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.user_id
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid().."_" .. self.user_id
end


--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[106]--极品狐仙
end
--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "big_logo_hi6"
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_empty"
end

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	self.is_init = true
	self.user_id = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	
	AgentMs:InitLocalPush()

	PlatformBinder:JsonBind("call_agent_login", function(arg)
		self:LoginCallback(arg)
		return true
	end)

	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)

	PlatformBinder:JsonBind("call_agent_pay", function(arg)
		self:PayCallback(arg)
		return true
	end)


	GlobalEventSystem:Bind(LoginEventType.ENTER_GAME_SERVER_SUCC, function()
		self:SetUserInfo()
	end)
end



-- 登录
function AgentAdapter:Login()
	if self.login_flag and "" ~= self.user_id then
		LoginController.Instance:LoginPlatSucc(self:GetPlatName(), self.session_id)
		return
	end

	PlatformBinder:JsonCall("call_agent_login")
end

-- 登出
function AgentAdapter:Logout()
	PlatformBinder:JsonCall("call_agent_logout")
end

-- 是否有管理中心
function AgentAdapter:IsHasManagerCenter()
	return false
end

-- 打开管理中心
function AgentAdapter:OpenManagerCenter()
	if self:IsHasManagerCenter() then
		PlatformBinder:JsonCall("call_agent_manager_center")
	end
end

-- 悬浮按钮
function AgentAdapter:ShowFloatButton()
end

-- 支付
function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)
	local arg_t = {
	    ["product_name"] = amount * 10 .. "元宝",
		["amount"] = amount,
		["order_id"] = server_id .. "_" .. role_id .. "_" .. os.time(),
		["pay_callback_url"] =self.pay_callback_url
	}

	local arg = cjson.encode(arg_t)
	PlatformBinder:JsonCall("call_agent_pay", arg)
end

function AgentAdapter:OnClickBackLogin()
	PlatformBinder:JsonCall("call_agent_logout")
end

function AgentAdapter:SetUserInfo()

end

-- 登录回调
function AgentAdapter:LoginCallback(arg)
	local ret_t = cjson.decode(arg)
	if 1 == ret_t.ret then	-- 切换账号
		ReStart()
		return
	end

	self.login_flag = true
	self.user_id = ret_t.user_id
	self.session_id = ret_t.session_id

	LoginController.Instance:LoginPlatSucc(self:GetPlatName(), self.session_id)
end

-- 登出回调
function AgentAdapter:LogoutCallback(arg)
	self.login_flag = false
	self.user_id = ""
	self.session_id = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
end

-- 支付回调
function AgentAdapter:PayCallback(arg)
	
end



-- 是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end